/********************************************************************************
 * Copyright (C) 2021 Jon Radchenko and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
import URI from '@theia/core/lib/common/uri';
import { OpenHandler, OpenerService } from '@theia/core/lib/browser';
import { ServerProxyInstanceManager } from 'theia-server-proxy-extension/lib/browser/server-proxy-instance-manager';
import { WorkspaceService } from '@theia/workspace/lib/browser/workspace-service';
export declare class RStudioOpenHandler implements OpenHandler {
    readonly id = "rstudio.openhandler";
    readonly label = "Open in RStudio";
    protected readonly workspaceService: WorkspaceService;
    protected readonly serverProxyInstanceManager: ServerProxyInstanceManager;
    protected readonly openerService: OpenerService;
    private readonly logger;
    canHandle(uri: URI): number;
    private fallback;
    open(uri: URI): Promise<object | undefined>;
}
//# sourceMappingURL=rstudio-open-handler.d.ts.map