"use strict";
/********************************************************************************
 * Copyright (C) 2021 Jon Radchenko and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RStudioServerProxyContribution = exports.RStudioServerProxyInstanceBuilder = void 0;
var http_proxy_middleware_1 = require("http-proxy-middleware");
var inversify_1 = require("inversify");
var server_proxy_contribution_1 = require("theia-server-proxy-extension/lib/node/server-proxy-contribution");
var server_proxy_1 = require("theia-server-proxy-extension/lib/common/server-proxy");
var os = require("os");
var const_1 = require("../common/const");
var RStudioServerProxyInstanceBuilder = /** @class */ (function (_super) {
    __extends(RStudioServerProxyInstanceBuilder, _super);
    function RStudioServerProxyInstanceBuilder() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.id = const_1.Extension.ID;
        return _this;
    }
    RStudioServerProxyInstanceBuilder.prototype.build = function (instanceId, relativeUrl, context) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(!this.instance || server_proxy_1.ServerProxyInstanceStatus.isCompleted(this.instance.status))) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, _super.prototype.build.call(this, instanceId, relativeUrl, context)];
                    case 1:
                        _a.instance = _b.sent();
                        _b.label = 2;
                    case 2: return [2 /*return*/, this.instance];
                }
            });
        });
    };
    RStudioServerProxyInstanceBuilder.prototype.getCommand = function (relativeUrl, context) {
        return __awaiter(this, void 0, void 0, function () {
            var port, command;
            return __generator(this, function (_a) {
                port = 8787;
                command = [
                    "/usr/lib/rstudio-server/bin/rserver",
                    "--server-daemonize=0",
                    "--auth-none=1",
                    "--www-frame-origin=any",
                    "--www-port=" + port.toString(),
                    "--auth-minimum-user-id=0" //allow root
                ];
                return [2 /*return*/, {
                        port: port,
                        command: command,
                        env: {
                            "USER": os.userInfo().username
                        }
                    }];
            });
        });
    };
    RStudioServerProxyInstanceBuilder = __decorate([
        inversify_1.injectable()
    ], RStudioServerProxyInstanceBuilder);
    return RStudioServerProxyInstanceBuilder;
}(server_proxy_contribution_1.BaseServerProxyInstanceBuilder));
exports.RStudioServerProxyInstanceBuilder = RStudioServerProxyInstanceBuilder;
var RStudioServerProxyContribution = /** @class */ (function () {
    function RStudioServerProxyContribution(serverProxyInstanceBuilder) {
        this.serverProxyInstanceBuilder = serverProxyInstanceBuilder;
        this.id = "rstudio";
        this.name = "RStudio";
    }
    RStudioServerProxyContribution.prototype.getMiddleware = function (basePath, baseOptions) {
        var _this = this;
        baseOptions.pathRewrite = { '^(/[^ /]*){3}': '' };
        baseOptions.onProxyRes = function (proxyRes, req, res) {
            var redirect = proxyRes.headers.location;
            if (!redirect) {
                return;
            }
            var serverProxyBasePath = req.serverProxyBasePath;
            var hostname = req.headers["host"];
            // TODO https
            // this should probably be changed altogether to not depend on the user's request
            redirect = redirect.replace('http://localhost:8787/', "http://" + hostname + serverProxyBasePath);
            console.log("Settings redirect from '" + proxyRes.headers.location + "' to '" + redirect + "'");
            proxyRes.headers.location = redirect;
        };
        var baseOnProxyReq = baseOptions.onProxyReq;
        baseOptions.onProxyReq = function (proxyReq, request, response) {
            var _a;
            if (request.url == "/rpc/set_user_state") {
                var json = request.body;
                _this.clientId = json.clientId;
                _this.clientVersion = json.clientVersion;
                _this.csrfToken = (_a = request.headers["x-csrf-token"]) === null || _a === void 0 ? void 0 : _a.toString();
            }
            else if (request.url == '/rpc/theia_remote') {
                if (!request.body || !_this.csrfToken || !_this.clientVersion || !_this.clientId) {
                    // TODO return an unhandled or something
                    baseOnProxyReq === null || baseOnProxyReq === void 0 ? void 0 : baseOnProxyReq(proxyReq, request, response);
                    return;
                }
                var body = request.body;
                delete request.body;
                body.clientId = _this.clientId;
                body.clientVersion = _this.clientVersion;
                var bodyStringified = JSON.stringify(body);
                proxyReq.setHeader('Content-Length', bodyStringified.length);
                proxyReq.setHeader('X-CSRF-Token', _this.csrfToken);
                proxyReq.path = '/rpc/console_input';
                proxyReq.write(bodyStringified);
                return;
            }
            baseOnProxyReq === null || baseOnProxyReq === void 0 ? void 0 : baseOnProxyReq(proxyReq, request, response);
        };
        return http_proxy_middleware_1.createProxyMiddleware(basePath, baseOptions);
    };
    RStudioServerProxyContribution = __decorate([
        inversify_1.injectable(),
        __param(0, inversify_1.inject(RStudioServerProxyInstanceBuilder)),
        __metadata("design:paramtypes", [RStudioServerProxyInstanceBuilder])
    ], RStudioServerProxyContribution);
    return RStudioServerProxyContribution;
}());
exports.RStudioServerProxyContribution = RStudioServerProxyContribution;
//# sourceMappingURL=rstudio-server-proxy-contribution.js.map